// Snippet! Can't be compiled or used
// (c) 2004 Volodymyr 'voland' Kyselyov

// CInitClient.cpp : implementation file
//

#include "stdafx.h"
#include "ViRene_Utils.h"
#include "VoiceChat.h"
#include "CInitClient.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CInitClient

CInitClient::CInitClient( )
{
	m_nEntered = 0;
	
	INITCLIENT_ENTERED( );

	_SwitchToState( IC_UNKNOWN );

	m_csRemoteAddress = "";
	m_nRemotePort = 0;

	m_csRemoteListenerAddress = "";
	m_nRemoteListenerPort = 0;

//   _SwitchToState()
//	m_dwStateSwitchedTime = GetTickCount( );

	INITCLIENT_LEFT( );
}

CInitClient::~CInitClient()
{
	INITCLIENT_ENTERED( );

	if( m_enState != IC_CONNECTION_CLOSED_BY_REMOTE ) {

		//     
		_tagInfoPacket		stInfoPacket;
		stInfoPacket.nErrCode = PEC_CLIENT_CLOSE_CONNECTION;
		
		CSocket::SendTo( &stInfoPacket, sizeof(stInfoPacket), m_nRemotePort, m_csRemoteAddress );
	}

	INITCLIENT_LEFT( );
}


// Do not edit the following lines, which are needed by ClassWizard.
#if 0
BEGIN_MESSAGE_MAP(CInitClient, CSocket)
	//{{AFX_MSG_MAP(CInitClient)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
#endif	// 0

/////////////////////////////////////////////////////////////////////////////
// CInitClient member functions

void CInitClient::OnReceive(int nErrorCode) 
{
	// TODO: Add your specialized code here and/or call the base class

	INITCLIENT_ENTERED( );

	if( nErrorCode ) {

		_SwitchToState( IC_WINSOCK_ERROR );

		CSocket::OnReceive(nErrorCode);
		INITCLIENT_LEFT( );
		return;
	}

//----------------------------------------
	int					nRes			= 0;

	static BYTE			pPeekBuffer[40*1024];
	CString				csPeekAddress	= "";
	UINT				nPeekPort		= 0;

	//  PeekBuffer    
	ZERO_ARRAY( pPeekBuffer );
	
	nRes = CSocket::ReceiveFrom( (void*)pPeekBuffer, sizeof(pPeekBuffer), csPeekAddress, nPeekPort, MSG_PEEK );
	if( nRes == SOCKET_ERROR || nRes == 0 ) {

		_SwitchToState( IC_PEEKPACKET_ERROR );
		INITCLIENT_LEFT( );
		return;
	}

	//   
	VI_PACKET_TYPE enPacketType = ((_tagInitPacket*)pPeekBuffer)->enType;

	switch( _GetState() ) {
//====================================================================
	case IC_CONNECTED :

		switch( enPacketType ) {
		case PT_KEEPALIVE :
			
			/*  Keep-Alive */
			break;
		case PT_INFO :
			{
				/*    */
				CString csInfoRemoteAddress = "";
				UINT nInfoRemotePort = 0;
				
				//  -  
				_tagInfoPacket		stInfoPacket;
				
				nRes = CSocket::ReceiveFrom( &stInfoPacket, sizeof(stInfoPacket), csInfoRemoteAddress, nInfoRemotePort );

				if( nRes != SOCKET_ERROR && nRes != 0 ) {
					
					switch( stInfoPacket.nErrCode ) {
					case PEC_SERVER_CLOSE_CONNECTION :
						_SwitchToState( IC_CONNECTION_CLOSED_BY_REMOTE );
						break;
						// ADD MORE...
					} // end of switch( stInfoPacket.nErrCode )
				}
			}
			break;
		case PT_VOICE :

			break;
		case PT_VIDEO :

			break;
		case PT_INIT :
		case PT_FIN :
		default :
			//   
			CString				csDummyRemoteAddress;
			UINT				nDummyRemotePort;
			Vi_PurgeUDPSocketQueue( this, csDummyRemoteAddress, nDummyRemotePort );
			
			ErrorMsg( "UNEXPECTED PACKET ARRIVED!" );
			INITCLIENT_LEFT( );
			return;
		} // end of switch( enPacketType )
		break;
//====================================================================
	case IC_WAITING_FOR_ACKPACKET :

		if( enPacketType == PT_ACK )
		{
			CString csAckRemoteAddress	= "";
			UINT nAckRemotePort			= 0;
			
			//       
			_tagAckPacket		stAckPacket;
// 1) --> [Ack]
			nRes = CSocket::ReceiveFrom( &stAckPacket, sizeof(stAckPacket), csAckRemoteAddress, nAckRemotePort );
			if( nRes == SOCKET_ERROR || nRes == 0 ) {
				
				_SwitchToState( IC_ACKPACKET_RECEIVE_FAILED );
				INITCLIENT_LEFT( );
				return;
			}
			
			_SwitchToState( IC_ACKPACKET_RECEIVED );
			/******    ID'a
//[CODE REMOVED]
			********/
			if( stAckPacket.nErrCode != PEC_NO_ERROR ) {
				
				_SwitchToState( IC_HANDSHAKE_FAILURE );
				
				ErrorMsg( CString("Handshake Failure - ") + PEC2String( stAckPacket.nErrCode ) );
				INITCLIENT_LEFT( );
				return;
			}
			
//[CODE REMOVED]

			_SwitchToState( IC_FINPACKET_SENDING );
			
			//  
			_tagFinPacket		stFinPacket;
// 3) [Fin] -->
			nRes = CSocket::SendTo( &stFinPacket, sizeof(stFinPacket), m_nRemotePort, m_csRemoteAddress );
			if( nRes == SOCKET_ERROR || nRes == 0 ) {
				
				_SwitchToState( IC_FINPACKET_SEND_FAILED );
				INITCLIENT_LEFT( );
				return;
			}
			
			_SwitchToState( IC_FINPACKET_SENT );
			
			//     
			_SwitchToState( IC_WAITING_FOR_FINACKPACKET );
		} // if( enPacketType == PT_ACK )
		break; // case IC_WAITING_FOR_ACKPACKET
//====================================================================
	case IC_WAITING_FOR_FINACKPACKET :

		if( enPacketType == PT_ACK )
		{
			CString csFinAckRemoteAddress	= "";
			UINT nFinAckRemotePort			= 0;
			
			//       
			_tagAckPacket		stFinAckPacket;
// 1) --> [FinAck]			
			nRes = CSocket::ReceiveFrom( &stFinAckPacket, sizeof(stFinAckPacket), csFinAckRemoteAddress, nFinAckRemotePort );
			if( nRes == SOCKET_ERROR || nRes == 0 ) {
				
				_SwitchToState( IC_FINACKPACKET_RECEIVE_FAILED );
				INITCLIENT_LEFT( );
				return;
			}
			
			_SwitchToState( IC_FINACKPACKET_RECEIVED );
			
//[CODE REMOVED]
			
			if( stFinAckPacket.nErrCode != PEC_NO_ERROR ) {
				
				_SwitchToState( IC_HANDSHAKE_FAILURE );
				
				ErrorMsg( CString("Handshake Failure - ") + PEC2String( stFinAckPacket.nErrCode ) );
				INITCLIENT_LEFT( );
				return;
			}

			//       
			//    0.0.0.0,   Create()     :(
			GetSockName( m_csLocalAddress, m_nLocalPort );

			_SwitchToState( IC_CONNECTED );
			
		} // if( enPacketType == PT_FINACK )
	break; // case IC_WAITING_FOR_FINACKPACKET
//====================================================================
	// Expand Here...

//====================================================================
	default:
		{ //      
			CString				csDummyRemoteAddress;
			UINT				nDummyRemotePort;
			Vi_PurgeUDPSocketQueue( this, csDummyRemoteAddress, nDummyRemotePort );
		}

	} // switch( _GetState() )

//----------------------------------------
	CSocket::OnReceive(nErrorCode);

	INITCLIENT_LEFT( );
	return;
}

BOOL CInitClient::ConnectTo(CString csRemoteAddress, UINT nRemotePort)
{
	INITCLIENT_ENTERED( );

	if( _GetState() == IC_CONNECTED ) {

		ErrorMsg( "Already Connected" );
		INITCLIENT_LEFT( );
		return FALSE;
	}
	if( _GetState() != IC_READY_TO_CONNECT_TO ) {

		ErrorMsg( "Handshake in Progress" );
		INITCLIENT_LEFT( );
		return FALSE;
	}

	if( csRemoteAddress == "" ) {

		ErrorMsg( "Invalid RemoteAddress passed to ConnectTo()" );
		INITCLIENT_LEFT( );
		return FALSE;
	}
	if( nRemotePort <= 1024 ) {

		ErrorMsg( "Invalid RemotePort passed to ConnectTo()" );
		INITCLIENT_LEFT( );
		return FALSE;
	}

	//    dotted type
	unsigned int nPos = strspn( csRemoteAddress, ".0123456789" );
	if( nPos != strlen(csRemoteAddress) ) {

		hostent *hent = gethostbyname( csRemoteAddress );
		if( hent == NULL ) {

			ErrorMsg( "Can't resolve hostname in ConnectTo()" );
			INITCLIENT_LEFT( );
			return FALSE;
		}
		//   IP-
		char szTmp[64] = "";
		sprintf( szTmp, "%u.%u.%u.%u", (unsigned char)hent->h_addr_list[0][0], (unsigned char)hent->h_addr_list[0][1], (unsigned char)hent->h_addr_list[0][2], (unsigned char)hent->h_addr_list[0][3] );
		csRemoteAddress = szTmp;
	}
	m_csRemoteListenerAddress = csRemoteAddress;
	m_nRemoteListenerPort = nRemotePort;

	int nRes			= 0;
	_tagInitPacket		stInitPacket;

	//    
	_SwitchToState( IC_INITPACKET_SENDING );
// 1) <-- [Init]
	nRes = CSocket::SendTo( &stInitPacket, sizeof(stInitPacket), m_nRemoteListenerPort, m_csRemoteListenerAddress );
	if( nRes == SOCKET_ERROR || nRes == 0 ) {

		_SwitchToState( IC_INITPACKET_SEND_FAILED );
		INITCLIENT_LEFT( );
		return FALSE;
	}

	_SwitchToState( IC_INITPACKET_SENT );

	_SwitchToState( IC_WAITING_FOR_ACKPACKET );

	INITCLIENT_LEFT( );
	return TRUE;
}

//    InitClient'a
void CInitClient::_SwitchToState(INITCLIENT_STATE enState)
{
	INITCLIENT_ENTERED( );

	m_enState = enState;
	m_dwStateSwitchedTime = GetTickCount( );

	switch( m_enState ) {
/*
	case xxx :
	{
		;
	}
	break; // case xxx
//-----------------------------------------------------
*/
	case IC_CONNECTED :
	{
		CString csOkMessage;
		csOkMessage.Format( "Outgoing Connection to %s:%d successfully established on %s:%d", m_csRemoteAddress, m_nRemotePort, m_csLocalAddress, m_nLocalPort );
		InfoMsg( csOkMessage );
	}
	break; // case IC_CONNECTED
//-----------------------------------------------------
	case IC_CONNECTION_CLOSED_BY_REMOTE :
	{
		CString csOkMessage;
		csOkMessage.Format( "Remote Server at %s:%d have closed connection", m_csRemoteAddress, m_nRemotePort );
		InfoMsg( csOkMessage );
	}
	break; // case IC_CONNECTION_CLOSED_BY_REMOTE
//-----------------------------------------------------
	case IC_PEEKPACKET_ERROR :
	{
		ErrorMsg( "PeekPacket Error" );
	}
	break; // case I_PEEKPACKET_ERROR
//-----------------------------------------------------
	case IC_WINSOCK_ERROR :
	{
		ErrorMsg( "WINSOCK reports 'Network subsystem failed'" );
	}
	break; // case IC_WINSOCK_ERROR
//-----------------------------------------------------
	case IC_ACKPACKET_RECEIVE_FAILED :
	{
		int nSockErr = GetLastError( );
		ErrorMsg( "Failure on RecvAckPacket stage" );
	}
	break; // case IC_ACKPACKET_RECEIVE_FAILED
//-----------------------------------------------------
	case IC_FINPACKET_SEND_FAILED :
	{
		ErrorMsg( "Failure on SendFinPacket stage" );
	}
	break; // case IC_FINPACKET_SEND_FAILED
//-----------------------------------------------------
	case IC_FINACKPACKET_RECEIVE_FAILED :
	{
		ErrorMsg( "Failure on RecvFinAckPacket stage" );
	}
	break; // case IC_FINACKPACKET_RECEIVE_FAILED
//-----------------------------------------------------
	case IC_FINACKPACKET_ADDRESS_MISMATCH :
	{
		ErrorMsg( "Remote Address mismatch in FinAckPacket" );
	}
	break; // case IC_FINACKPACKET_ADDRESS_MISMATCH
//-----------------------------------------------------
	case IC_FINACKPACKET_PORT_MISMATCH :
	{
		ErrorMsg( "Remote Port mismatch in FinAckPacket" );
	}
	break; // case IC_FINACKPACKET_PORT_MISMATCH
//-----------------------------------------------------
	case IC_INITPACKET_SEND_FAILED :
	{
		ErrorMsg( "Failure on SendInitPacket stage" );
	}
	break; // case IC_INITPACKET_SEND_FAILED
//-----------------------------------------------------
	case IC_INIT_SOCKET_CREATE_FAILED :
	{
		ErrorMsg( "Can't create init socket" );
	}
	break; // case IC_INIT_SOCKET_CREATE_FAILED
//-----------------------------------------------------
	case IC_CONNECTED_TIMEOUT :
	{
		ErrorMsg( "Connection Timeout" );
	}
	break; // case IS_CONNECTED_TIMEOUT
//-----------------------------------------------------

	} // switch( m_enState )

	INITCLIENT_LEFT( );
}

int CInitClient::ErrorMsg(const char *szMsg)
{
	INITCLIENT_ENTERED( );

	int nRes = Vi_ErrorBox( CString("InitClient Error: ") + szMsg );

	INITCLIENT_LEFT( );
	return nRes;
}

void CInitClient::InfoMsg(const char *szMsg)
{
	INITCLIENT_ENTERED( );

	Vi_InfoBox( CString("InitClient: ") + szMsg );

	INITCLIENT_LEFT( );
}

BOOL CInitClient::Create(UINT nSocketPort, int nSocketType, LPCTSTR lpszSocketAddress)
{
	INITCLIENT_ENTERED( );

	if( ! CSocket::Create( nSocketPort, nSocketType, lpszSocketAddress ) ) {

		_SwitchToState( IC_INIT_SOCKET_CREATE_FAILED );
		INITCLIENT_LEFT( );
		return FALSE;
	}
	
	GetSockName( m_csLocalAddress, m_nLocalPort );

	_SwitchToState( IC_INIT_SOCKET_CREATED );

	_SwitchToState( IC_READY_TO_CONNECT_TO );

	INITCLIENT_LEFT( );
	return TRUE;
}
