// Snippet! Can't be compiled or used
// (c) 2004 Volodymyr 'voland' Kyselyov

// CInitServer.cpp : implementation file
//

#include "stdafx.h"
#include "ViRene_Utils.h"
#include "VoiceChat.h"
#include "CInitServer.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CInitServer

CInitServer::CInitServer( )
{
	m_nEntered = 0;

	INITSERVER_ENTERED( );

	_SwitchToState( IS_UNKNOWN );

	m_csRemoteAddress = "";
	m_nRemotePort = 0;

//   _SwitchToState()
//	m_dwStateSwitchedTime = GetTickCount( );

	m_dwLastIOPacketTime = GetTickCount( );
	m_nKANumRetries = 0;

	INITSERVER_LEFT( );
}

CInitServer::~CInitServer()
{
	INITSERVER_ENTERED( );

	if( m_enState != IS_CONNECTION_CLOSED_BY_REMOTE ) {

		//     
		_tagInfoPacket		stInfoPacket;
		stInfoPacket.nErrCode = PEC_SERVER_CLOSE_CONNECTION;
		
//--		CSocket::SendTo( &stInfoPacket, sizeof(stInfoPacket), m_nRemotePort, m_csRemoteAddress );
		Send( &stInfoPacket, sizeof(stInfoPacket) );
	}

	INITSERVER_LEFT( );
}


// Do not edit the following lines, which are needed by ClassWizard.
#if 0
BEGIN_MESSAGE_MAP(CInitServer, CSocket)
	//{{AFX_MSG_MAP(CInitServer)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
#endif	// 0

/////////////////////////////////////////////////////////////////////////////
// CInitServer member functions

void CInitServer::OnReceive(int nErrorCode) 
{
	// TODO: Add your specialized code here and/or call the base class

	INITSERVER_ENTERED( );

	if( nErrorCode ) {

		_SwitchToState( IS_WINSOCK_ERROR );

		CSocket::OnReceive(nErrorCode);
		INITSERVER_LEFT( );
		return;
	}
//----------------------------------------
	int					nRes			= 0;

	static BYTE			pPeekBuffer[40*1024];
	CString				csPeekAddress	= "";
	UINT				nPeekPort		= 0;

	// for Purging garbage
	CString				csDummyRemoteAddress;
	UINT				nDummyRemotePort;
	

	//  PeekBuffer    
	ZERO_ARRAY( pPeekBuffer );
	
	nRes = CSocket::ReceiveFrom( (void*)pPeekBuffer, sizeof(pPeekBuffer), csPeekAddress, nPeekPort, MSG_PEEK );
	if( nRes == SOCKET_ERROR || nRes == 0 ) {

		//   
		Vi_PurgeUDPSocketQueue( this, csDummyRemoteAddress, nDummyRemotePort );

		INT nErrCode = GetLastError();
		if( nErrCode == WSAECONNABORTED || nErrCode == WSAECONNRESET ) {

			if( _GetState() != IS_CONNECTION_CLOSED_BY_REMOTE ) {

				_SwitchToState( IS_CONNECTION_CLOSED_BY_REMOTE );
			}
		} else {

			if( _GetState() != IS_PEEKPACKET_ERROR ) {
				
				_SwitchToState( IS_PEEKPACKET_ERROR );
			}
		}
		INITSERVER_LEFT( );
		return;
	}

	//    / 
	m_dwLastIOPacketTime = GetTickCount( );

	//   
	VI_PACKET_TYPE enPacketType = ((_tagInitPacket*)pPeekBuffer)->enType;

	switch( _GetState() ) {
//====================================================================
	case IS_CONNECTED :

		switch( enPacketType ) {
		case PT_KEEPALIVE :
			{			
				/*  Keep-Alive */
				
				//   
				Vi_PurgeUDPSocketQueue( this, csDummyRemoteAddress, nDummyRemotePort );

				//   
				m_dwStateSwitchedTime = m_dwLastIOPacketTime;
				Beep( 2000, 10 );
			}
			break;
		case PT_INFO :
			{
				/*    */
				CString csInfoRemoteAddress = "";
				UINT nInfoRemotePort = 0;
				
				//  -  
				_tagInfoPacket		stInfoPacket;
				
				nRes = CSocket::ReceiveFrom( &stInfoPacket, sizeof(stInfoPacket), csInfoRemoteAddress, nInfoRemotePort );

				if( nRes != SOCKET_ERROR && nRes != 0 ) {
					
					switch( stInfoPacket.nErrCode ) {
					case PEC_CLIENT_CLOSE_CONNECTION :
						_SwitchToState( IS_CONNECTION_CLOSED_BY_REMOTE );
						break;
						// ADD MORE...
					} // end of switch( stInfoPacket.nErrCode )
				}
			}
			break;
		case PT_VOICE :

			//      ,  ...
			//      ,  ...
			//      ,  ...
			break;
		case PT_VIDEO :

			//      ,  ...
			//      ,  ...
			//      ,  ...
			break;
		case PT_INIT :
		case PT_FIN :
		default :
			//   
			Vi_PurgeUDPSocketQueue( this, csDummyRemoteAddress, nDummyRemotePort );
			
			ErrorMsg( "Only ONE client per server allowed" );
			INITSERVER_LEFT( );
			return;
		} // end of switch( enPacketType )
		break;
//====================================================================
	case IS_WAITING_FOR_FINPACKET :

		if( enPacketType == PT_FIN )
		{
			CString csFinRemoteAddress = "";
			UINT nFinRemotePort = 0;
			
			//       
			_tagFinPacket		stFinPacket;
// 3) --> [Fin]
			nRes = CSocket::ReceiveFrom( &stFinPacket, sizeof(stFinPacket), csFinRemoteAddress, nFinRemotePort );
			if( nRes == SOCKET_ERROR || nRes == 0 ) {
				
				_SwitchToState( IS_FINPACKET_RECEIVE_FAILED );
				INITSERVER_LEFT( );
				return;
			}
			
			_SwitchToState( IS_FINPACKET_RECEIVED );
			
			if( csFinRemoteAddress != m_csRemoteAddress ) {

				//    
				_tagAckPacket		stFinAckErrorPacket;
				stFinAckErrorPacket.nErrCode = PEC_CONNECTION_REJECTED;
				Vi_SendErrorPacket( this, csFinRemoteAddress, nFinRemotePort, &stFinAckErrorPacket, sizeof(stFinAckErrorPacket) );

				_SwitchToState( IS_FINPACKET_ADDRESS_MISMATCH );
				INITSERVER_LEFT( );
				return;
			}
			
			if( nFinRemotePort != m_nRemotePort ) {
				
				//    
				_tagAckPacket		stFinAckErrorPacket;
				stFinAckErrorPacket.nErrCode = PEC_CONNECTION_REJECTED;
				Vi_SendErrorPacket( this, csFinRemoteAddress, nFinRemotePort, &stFinAckErrorPacket, sizeof(stFinAckErrorPacket) );

				_SwitchToState( IS_FINPACKET_PORT_MISMATCH );
				INITSERVER_LEFT( );
				return;
			}

			if( stFinPacket.nErrCode != PEC_NO_ERROR ) {
				
				_SwitchToState( IS_HANDSHAKE_FAILURE );
				
				ErrorMsg( CString("Handshake Failure - ") + PEC2String( stFinPacket.nErrCode ) );
				INITSERVER_LEFT( );
				return;
			}
			
			//   FinAck-  SendTo()
			CString csFinAckRemoteAddress = "";
			UINT nFinAckRemotePort = 0;
			
			_SwitchToState( IS_FINACKPACKET_SENDING );
			
			//  
			_tagAckPacket		stFinAckPacket;
// 4) [FinAck] -->
//rr			nRes = CSocket::SendTo( &stFinAckPacket, sizeof(stFinAckPacket), m_nRemotePort, m_csRemoteAddress );
			nRes = Send( &stFinAckPacket, sizeof(stFinAckPacket) );
			if( nRes == SOCKET_ERROR || nRes == 0 ) {
				
				_SwitchToState( IS_FINACKPACKET_SEND_FAILED );
				INITSERVER_LEFT( );
				return;
			}
			
			_SwitchToState( IS_FINACKPACKET_SENT );

			_SwitchToState( IS_CONNECTED );
		} // if( enPacketType == PT_FIN )
		break;  // case IS_WAITING_FOR_FINPACKET
//====================================================================
	// Expand Here...
//====================================================================
	default :
		{ //      
			CString				csDummyRemoteAddress;
			UINT				nDummyRemotePort;
			Vi_PurgeUDPSocketQueue( this, csDummyRemoteAddress, nDummyRemotePort );
		}
		break;
	} // switch( _GetState() )

	// 1)   
	// 2)   Client<->Server
	// 3)  ,       IDC_SENDVOICE

//---------------------------------	
	CSocket::OnReceive(nErrorCode);
	INITSERVER_LEFT( );
	return;
}

//    InitServer'a
void CInitServer::_SwitchToState(INITSERVER_STATE enState)
{
	INITSERVER_ENTERED( );

	m_enState = enState;
	m_dwStateSwitchedTime = GetTickCount( );

	switch( m_enState ) {
/*
	case xxx :
	{
		;
	}
	break; // case xxx
//-----------------------------------------------------
*/
	case IS_CONNECTED :
	{
		m_nKANumRetries = 0;		//  -   

		CString csOkMessage;
		csOkMessage.Format( "Incoming Connection from %s:%d successfully accepted on %s:%d", m_csRemoteAddress, m_nRemotePort, m_csLocalAddress, m_nLocalPort );
		InfoMsg( csOkMessage );
	}
	break; // case IS_CONNECTED
//-----------------------------------------------------
	case IS_CONNECTION_CLOSED :
	{
		m_nKANumRetries = 0;		//  -   

		CString csOkMessage;
		csOkMessage.Format( "Connection to Remote Client at %s:%d have closed", m_csRemoteAddress, m_nRemotePort );
		InfoMsg( csOkMessage );
	}
	break; // case IS_CONNECTION_CLOSED_BY_REMOTE
//-----------------------------------------------------
	case IS_CONNECTION_CLOSED_BY_REMOTE :
	{
		m_nKANumRetries = 0;		//  -   

		CString csOkMessage;
		csOkMessage.Format( "Remote Client at %s:%d have closed connection", m_csRemoteAddress, m_nRemotePort );
		InfoMsg( csOkMessage );
	}
	break; // case IS_CONNECTION_CLOSED_BY_REMOTE
//-----------------------------------------------------
	case IS_PEEKPACKET_ERROR :
	{
		ErrorMsg( "PeekPacket Error" );
	}
	break; // case IS_PEEKPACKET_ERROR
//-----------------------------------------------------
	case IS_WINSOCK_ERROR :
	{
		ErrorMsg( "WINSOCK reports 'Network subsystem failed'" );
	}
	break; // case IS_WINSOCK_ERROR
//-----------------------------------------------------
	case IS_FINPACKET_RECEIVE_FAILED :
	{
		ErrorMsg( "Failure on RecvFinPacket stage" );
	}
	break; // case IS_FINPACKET_RECEIVE_FAILED
//-----------------------------------------------------
	case IS_FINPACKET_ADDRESS_MISMATCH :
	{
		ErrorMsg( "Remote Address mismatch in FinPacket" );
	}
	break; // case IS_FINPACKET_ADDRESS_MISMATCH
//-----------------------------------------------------
	case IS_FINPACKET_PORT_MISMATCH :
	{
		ErrorMsg( "Remote Port mismatch in FinPacket" );
	}
	break; // case IS_FINPACKET_PORT_MISMATCH
//-----------------------------------------------------
	case IS_FINACKPACKET_SEND_FAILED :
	{
		ErrorMsg( "Failure on SendFinAckPacket stage" );
	}
	break; // case IS_FINACKPACKET_SEND_FAILED
//-----------------------------------------------------
	case IS_ACKPACKET_SEND_FAILED :
	{
		ErrorMsg( "Failure on SendAckPacket stage" );
	}
	break; // case IS_ACKPACKET_SEND_FAILED
//-----------------------------------------------------
	case IS_INIT_SOCKET_CREATE_FAILED :
	{
		ErrorMsg( "Can't create init socket" );
	}
	break; // case IS_INIT_SOCKET_CREATE_FAILED
//-----------------------------------------------------
	case IS_CONNECTED_TIMEOUT :
	{
		ErrorMsg( "Connection Timeout" );
	}
	break; // case IS_CONNECTED_TIMEOUT
//-----------------------------------------------------
	case IS_KEEPALIVE_SENDING_FAILED :
	{
		if( m_nKANumRetries < KEEPALIVE_NUM_RETRIES ) {
		
			++m_nKANumRetries;
			m_enState = IS_CONNECTED;	//     
			ErrorMsg( "Sending KEEP_ALIVE Query to Client failed" );
		} else {

			_SwitchToState( IS_CONNECTED_TIMEOUT );
		}
	}
	break; // case IS_CONNECTED_TIMEOUT
//-----------------------------------------------------

	} // switch( m_enState )

	INITSERVER_LEFT( );
}

int CInitServer::ErrorMsg(const char *szMsg, BOOL bShowBox /*= FALSE*/ )
{
	INITSERVER_ENTERED( );

	int nRes = Vi_ErrorMsg( CString("InitServer Error: ") + szMsg, bShowBox );

	INITSERVER_LEFT( );
	return nRes;

}

void CInitServer::InfoMsg(const char *szMsg, BOOL bShowBox /*= FALSE*/ )
{
	INITSERVER_ENTERED( );

	Vi_InfoMsg( CString("InitServer: ") + szMsg, bShowBox );

	INITSERVER_LEFT( );
}

BOOL CInitServer::AcceptFrom(CString csRemoteAddress, UINT nRemotePort)
{
	INITSERVER_ENTERED( );

	if( _GetState() == IS_CONNECTED ) {

		ErrorMsg( "Already Connected" );
		INITSERVER_LEFT( );
		return FALSE;
	}
	if( _GetState() != IS_READY_TO_ACCEPT_FROM ) {

		ErrorMsg( "Handshake in Progress" );
		INITSERVER_LEFT( );
		return FALSE;
	}

	if( csRemoteAddress == "" ) {

		ErrorMsg( "Invalid RemoteAddress passed to AcceptFrom()" );
		INITSERVER_LEFT( );
		return FALSE;
	}
	if( nRemotePort <= 1024 ) {

		ErrorMsg( "Invalid RemotePort passed to AcceptFrom()" );
		INITSERVER_LEFT( );
		return FALSE;
	}

	//    dotted type
	unsigned int nPos = strspn( csRemoteAddress, ".0123456789" );
	if( nPos != strlen(csRemoteAddress) ) {

		hostent *hent = gethostbyname( csRemoteAddress );
		if( hent == NULL ) {

			ErrorMsg( "Can't resolve hostname in ConnectTo()" );
			INITSERVER_LEFT( );
			return FALSE;
		}
		//   IP-
		char szTmp[64] = "";
		sprintf( szTmp, "%u.%u.%u.%u", (unsigned char)hent->h_addr_list[0][0], (unsigned char)hent->h_addr_list[0][1], (unsigned char)hent->h_addr_list[0][2], (unsigned char)hent->h_addr_list[0][3] );
		csRemoteAddress = szTmp;
	}
	m_csRemoteAddress = csRemoteAddress;
	m_nRemotePort = nRemotePort;
//-------------------------------------------------------
	_tagAckPacket		stAckPacket;
	int					nRes = 0;

	_SwitchToState( IS_ACKPACKET_SENDING );
// 2) [Ack] -->	
	//  
//rr	nRes = CSocket::SendTo( &stAckPacket, sizeof(stAckPacket), m_nRemotePort, m_csRemoteAddress );
	nRes = Send( &stAckPacket, sizeof(stAckPacket) );
	if( nRes == SOCKET_ERROR || nRes == 0 ) {
		
		_SwitchToState( IS_ACKPACKET_SEND_FAILED );
		INITSERVER_LEFT( );
		return FALSE;
	}
	
	_SwitchToState( IS_ACKPACKET_SENT );
	
	_SwitchToState( IS_WAITING_FOR_FINPACKET );

	INITSERVER_LEFT( );
	return TRUE;
}

BOOL CInitServer::Create(UINT nSocketPort, int nSocketType, LPCTSTR lpszSocketAddress)
{
	INITSERVER_ENTERED( );

	if( ! CSocket::Create( nSocketPort, nSocketType, lpszSocketAddress ) ) {

		_SwitchToState( IS_INIT_SOCKET_CREATE_FAILED );
		INITSERVER_LEFT( );
		return FALSE;
	}
	
	GetSockName( m_csLocalAddress, m_nLocalPort );

	_SwitchToState( IS_INIT_SOCKET_CREATED );

	_SwitchToState( IS_READY_TO_ACCEPT_FROM );

	INITSERVER_LEFT( );
	return TRUE;
}

int CInitServer::Send(const void* lpBuf, int nBufLen, int nFlags) 
{
	// TODO: Add your specialized code here and/or call the base class
	INITSERVER_ENTERED( );

	int nRes = CSocket::SendTo( lpBuf, nBufLen, m_nRemotePort, m_csRemoteAddress, nFlags );
/*
	if( nRes != SOCKET_ERROR && nRes != 0 ) {

		m_dwLastIOPacketTime = GetTickCount( );
	}
*/
	INITSERVER_LEFT( );
	return nRes;
}

void CInitServer::_SendKeepAlive(void *pData /* = NULL*/)
{
	INITSERVER_ENTERED( );

	//       - 
	if( _GetState() != IS_CONNECTED ) {

		INITSERVER_LEFT( );
		return;
	}

	//    KA   - 
	if( GetTickCount( ) - m_dwLastIOPacketTime <= SERVER2CLIENT_KEEPALIVE_INTERVAL ) {
		
		INITSERVER_LEFT( );
		return;
	}

	_tagInfoPacket stKAPacket;
	stKAPacket.enType = PT_KEEPALIVE;
	
	int nRes = Send( &stKAPacket, sizeof(stKAPacket) );
	if( nRes == SOCKET_ERROR || nRes == 0 ) {
		
		_SwitchToState( IS_KEEPALIVE_SENDING_FAILED );
	} else {

		m_nKANumRetries = 0;

		Beep( 1000, 15 );
	}

	INITSERVER_LEFT( );
}
